package client;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import com.borland.jbcl.layout.*;

public class Reversi extends JFrame {
  int numDivisoes;
  Tabuleiro tabuleiro = new Tabuleiro(this);
  JLabel lbStatus = new JLabel();
  JMenuItem mnuConfig = new JMenuItem();
  JMenuItem mnuIniciar = new JMenuItem();
  JMenuItem mnuParar = new JMenuItem();
  JRadioButtonMenuItem mnuIniciante = new JRadioButtonMenuItem();
  JRadioButtonMenuItem mnuIntermediario = new JRadioButtonMenuItem();
  JRadioButtonMenuItem mnuAvancado = new JRadioButtonMenuItem();
  JCheckBoxMenuItem mnuCorteAlfaBeta = new JCheckBoxMenuItem();

  //Construct the frame
  public Reversi() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    JPanel painelTabuleiro = new JPanel();
    JMenuItem mnuSair = new JMenuItem();
    JMenuBar menu = new JMenuBar();
    JMenuItem mnuReversi = new JMenuItem();
    TitledBorder titledBorder1;
    JMenu mnuDificuldade = new JMenu();
    ButtonGroup grpMenuDificuldade = new ButtonGroup();
    JMenu mnuJogo = new JMenu();
    JMenu mnuSobre = new JMenu();
    XYLayout xYLayout1 = new XYLayout();
    Border border1 = BorderFactory.createLineBorder(
        SystemColor.controlText, 1);
    titledBorder1 = new TitledBorder(border1, "Tabuleiro");
    this.setJMenuBar(menu);
    this.setSize(new Dimension(445, 532));
    this.setTitle("Trabalho de IA - Reversi/Othelo");
    this.setIconImage(getToolkit().createImage("img//reversi.gif"));
    mnuJogo.setText("Jogo");
    mnuJogo.setIcon(new ImageIcon("img//jogo.gif"));
    mnuSobre.setText("Sobre");
    mnuSobre.setIcon(new ImageIcon("img//sobre.gif"));
    mnuIniciar.setEnabled(false);
    mnuIniciar.setText("Iniciar");
    mnuIniciar.setIcon(new ImageIcon("img//iniciar.gif"));
    mnuIniciar.addActionListener(new Reversi_mnuIniciar_actionAdapter(this));
    mnuReversi.setText("Reversi / Othelo");
    mnuReversi.setIcon(new ImageIcon("img//grupo.gif"));
    mnuReversi.addActionListener(new Reversi_mnuReversi_actionAdapter(this));
    painelTabuleiro.setLayout(xYLayout1);
    painelTabuleiro.setBorder(titledBorder1);
    tabuleiro.setDropTarget(null);
    tabuleiro.setEnabled(true);
    tabuleiro.setVisible(true);
    xYLayout1.setWidth(400);
    xYLayout1.setHeight(400);
    mnuParar.addActionListener(new Reversi_mnuParar_actionAdapter(this));
    mnuParar.setIcon(new ImageIcon("img//parar.gif"));
    mnuParar.setEnabled(false);
    mnuParar.setText("Parar");
    mnuSair.setText("Sair");
    mnuSair.setIcon(new ImageIcon("img//sair.gif"));
    mnuSair.addActionListener(new Reversi_mnuSair_actionAdapter(this));
    mnuConfig.setText("Configurar Tabuleiro");
    mnuConfig.addActionListener(new Reversi_mnuConfig_actionAdapter(this));
    mnuConfig.setIcon(new ImageIcon("img//config.gif"));
    mnuDificuldade.setIcon(new ImageIcon("img//nivel.gif"));
    mnuDificuldade.setText("Nvel de Dificuldade");
    grpMenuDificuldade.add(mnuIniciante);
    grpMenuDificuldade.add(mnuIntermediario);
    grpMenuDificuldade.add(mnuAvancado);
    mnuIniciante.setText("Iniciante");
    mnuIntermediario.setAlignmentX((float) 0.5);
    mnuIntermediario.setText("Intermedirio");
    mnuAvancado.setText("Avanado");
    menu.add(mnuJogo);
    menu.add(mnuSobre);
    mnuJogo.add(mnuDificuldade);
    mnuCorteAlfaBeta = new JCheckBoxMenuItem();
    mnuCorteAlfaBeta.setText("Corte Alfa-Beta");
    mnuCorteAlfaBeta.setIcon(new ImageIcon("img//corte.gif"));
    mnuJogo.add(mnuCorteAlfaBeta);
    mnuJogo.add(mnuConfig);
    mnuJogo.addSeparator();
    mnuJogo.add(mnuIniciar);
    mnuJogo.add(mnuParar);
    mnuJogo.addSeparator();
    mnuJogo.add(mnuSair);
    mnuSobre.add(mnuReversi);
    painelTabuleiro.add(tabuleiro, new XYConstraints(10, 10, 410, 410));
    JPanel pnGeral = new JPanel(new BorderLayout());
    pnGeral.add(BorderLayout.SOUTH,
        lbStatus = new JLabel(" Configure o tabuleiro e inicie."));
    pnGeral.add(painelTabuleiro);
    this.getContentPane().add(pnGeral);
    mnuDificuldade.add(mnuIniciante);
    mnuDificuldade.add(mnuIntermediario);
    mnuDificuldade.add(mnuAvancado);
    mnuIntermediario.setSelected(true);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void mnuSair_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void mnuIniciar_actionPerformed(ActionEvent e) {
    tabuleiro.setNumDivisoes(this.numDivisoes);
    tabuleiro.initialize();
    mnuParar.setEnabled(true);
    mnuConfig.setEnabled(false);
    mnuIniciar.setEnabled(false);
  }

  void mnuConfig_actionPerformed(ActionEvent e) {
    boolean cancelou=false;
    int temp = 1;
    do {
      String num = JOptionPane.showInputDialog(this,
          "Entre com o Nmero de Divises:",
          "Configurao", JOptionPane.QUESTION_MESSAGE);
      if (num != null && !num.trim().equals(""))
        try {
          temp = Integer.valueOf(num).intValue();
        }
        catch (NumberFormatException ex) {
        }
      else
        cancelou=true;
      if (!cancelou)
        if (temp%2!=0)
          JOptionPane.showMessageDialog(this,
              "O nmero de divises deve ser par.",
              "Aviso", JOptionPane.OK_OPTION);
        else
          if (temp <= 4)
            JOptionPane.showMessageDialog(this,
                "O nmero de divises deve ser maior que 4.",
                "Aviso", JOptionPane.OK_OPTION);
    } while (!cancelou && (temp%2!=0 || temp <= 4));

    if (!cancelou)
    {
      numDivisoes = temp;
      mnuIniciar.setEnabled(true);
      mnuIniciar_actionPerformed(e);
    }
  }

  boolean isParado()
  {
    return !mnuParar.isEnabled();
  }

  void mostraStatus(String pStatus)
  {
    tabuleiro.atualizaPontos();

    if (pStatus != null)
      pStatus = "  -  " + pStatus + "!";

    lbStatus.setText(" Jogadas: "+tabuleiro.jogadas+
        "  -  Voc x Computador: "+tabuleiro.pontosUsuario
        +" x "+tabuleiro.pontosComputador + pStatus);
    this.paintAll(this.getGraphics());
  }

  boolean comCorte()
  {
    return mnuCorteAlfaBeta.getState();
  }

  void fimDeJogo()
  {
    mostraStatus("Fim de Jogo");

    String resultado = "Resultado:"+
        "\n   Jogador: "+tabuleiro.pontosUsuario+" pontos"+
        "\n   Computador: "+tabuleiro.pontosComputador+" pontos\n\n";
    if (tabuleiro.pontosComputador == tabuleiro.pontosUsuario)
      resultado += "O jogo terminou empatado!";
    else
      if (tabuleiro.pontosComputador > tabuleiro.pontosUsuario)
        resultado += "O computador venceu!";
      else
        resultado += "Voc venceu!";

    JOptionPane.showMessageDialog(this, resultado, "Fim do Jogo",
        JOptionPane.INFORMATION_MESSAGE);
    mnuParar_actionPerformed(null);
    mnuIniciar_actionPerformed(null);
  }

  void mnuParar_actionPerformed(ActionEvent e) {
    tabuleiro.finalize();
    mnuParar.setEnabled(false);
    mnuIniciar.setEnabled(true);
    mnuConfig.setEnabled(true);
  }

  void mnuReversi_actionPerformed(ActionEvent e) {
    String mensagem = "Trabalho de IA\n\n"+
        "Grupo:\n"+
        "   Dino Leonetti Junior\n"+
        "   Fabio Perez Marzullo";

    JOptionPane.showMessageDialog (this, mensagem, "Sobre...",
        JOptionPane.INFORMATION_MESSAGE);
  }

  public int alturaDificuldade() {
    if (mnuIniciante.isSelected()) {
      return 3;
    }
    if (mnuIntermediario.isSelected()) {
      return 5;
    }
    //mnuAvancado.isSelected())
    return 7;
  }
}

class Reversi_mnuIniciar_actionAdapter implements java.awt.event.ActionListener {
  Reversi adaptee;

  Reversi_mnuIniciar_actionAdapter(Reversi adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.mnuIniciar_actionPerformed(e);
  }
}

class Reversi_mnuParar_actionAdapter implements java.awt.event.ActionListener {
  Reversi adaptee;

  Reversi_mnuParar_actionAdapter(Reversi adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.mnuParar_actionPerformed(e);
  }
}

class Reversi_mnuReversi_actionAdapter implements java.awt.event.ActionListener {
  Reversi adaptee;

  Reversi_mnuReversi_actionAdapter(Reversi adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.mnuReversi_actionPerformed(e);
  }
}

class Reversi_mnuSair_actionAdapter implements java.awt.event.ActionListener {
  Reversi adaptee;

  Reversi_mnuSair_actionAdapter(Reversi adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.mnuSair_actionPerformed(e);
  }
}

class Reversi_mnuConfig_actionAdapter implements java.awt.event.ActionListener {
  Reversi adaptee;

  Reversi_mnuConfig_actionAdapter(Reversi adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.mnuConfig_actionPerformed(e);
  }
}